routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => 'language'], function () {
    Route::get('/', 'PhotosController@index')->name('mainpage');
    Route::resource('photos', 'PhotosController')->except('edit', 'update');
    Route::resource('users', 'UsersController')->except('index', 'create', 'store', 'destroy');
    Route::resource('photos.comments', 'CommentsController')->except('index', 'create')->middleware('auth');
    Auth::routes();
    Route::get('/home', 'HomeController@index')->name('home');
});

Route::get('language/{locale}', 'LanguageSwitcherController@switcher')
    ->name('language.switcher')
    ->where('locale', 'en|ru');

app/Comment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Orchid\Attachment\Attachable;
use Orchid\Filters\Filterable;
use Orchid\Screen\AsSource;

class Comment extends Model
{
    use AsSource, Attachable, Filterable;
    protected $fillable = ['user_id', 'photo_id', 'body', 'rate'];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function user() {
        return $this->belongsTo(User::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function post() {
        return $this->belongsTo(Post::class);
    }
}

app/Http/Controllers/CommentsController.php
<?php

namespace App\Http\Controllers;

use App\Comment;
use App\Http\Requests\CommentRequest;
use App\Photo;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class CommentsController extends Controller
{
    /**
     * @param CommentRequest $request
     * @param Photo $photo
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Throwable
     */
    public function store(CommentRequest $request, Photo $photo)
    {
        $validated = $request->validated();

        Auth::user();

        $comment = new Comment();
        $comment->body = $request->input('body');
        $comment->rate = $request->input('rate');
        $comment->photo_id = $photo->id;
        $comment->user_id = $request->user()->id;
        $comment->save();

        return redirect()->route('photos.show', compact('photo'))->with('message', 'New comment added!');
    }


    /**
     * @param Photo $photo
     * @param Comment $comment
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function edit(Photo $photo, Comment $comment)
    {
        $this->authorize('update', $comment);
        return view('comments.edit', compact('comment', 'photo'));
    }

    /**
     * @param CommentRequest $request
     * @param $photo
     * @param Comment $comment
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function update(CommentRequest $request, $photo, Comment $comment)
    {
        $comment->update($request->all());
        return redirect(route('photos.show', compact('comment', 'photo')))->with('message', 'Comment updated!');
    }


    /**
     * @param Photo $photo
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function destroy(Photo $photo, $id)
    {
        $comment = Comment::findOrFail($id);
        $this->authorize('delete', $comment);
        $comment->delete();
        return redirect()->route('photos.show', compact('photo'))->with('message', 'Comment deleted!');
    }
}

resources/views/comments/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container mt-2">
        <div class="col-10">
            <h5>Edit comment:</h5>
            <form method="post"
                  action="{{route('photos.comments.update', ['comment' => $comment, 'photo' => $photo])}}">
                @csrf
                @method('put')
                <div class="form-row mt-5">
                    <div class="form-group col-md-8">
                        <label for="body"><b>Comment</b></label><span class="text-danger">*</span>
                        <textarea rows="5" class="form-control @error('body') is-invalid @enderror" id="body"
                                  name="body">{{$comment->body}}</textarea>
                        @error('body')
                        <p class="error">{{$message}}</p>
                        @enderror
                    </div>
                    <div class="form-group col-md-8">
                        <label for="rate"><b>Score</b></label><span class="text-danger">*</span>
                        <select name="rate" id="rate" class="form-control @error('rate') is-invalid @enderror"
                                value="{{$comment->rate}}">
                            <option disabled>Choose score:</option>
                            <option>1</option>
                            <option>2</option>
                            <option>3</option>
                            <option>4</option>
                            <option>5</option>
                        </select>
                        @error('rate')
                        <p class="error">{{$message}}</p>
                        @enderror
                    </div>
                </div>
                <button type="submit" class="btn btn-primary active pl-4 pr-4 mr-3">Edit</button>
                <a href="{{route('photos.show', ['photo' => $photo])}}">Back</a>
            </form>
        </div>
    </div>
@endsection